#define Version "Codan8525A_FineTuneCalc"
/*
Generate the MC145159 fine tune table from the calculated numbers.
 */
long int FineTune []
{
// r        n       a         offset
0x26b3,   0x3f8,   0x2f,       0,   // actually 16 is as close to 000 as it gets
0x05df,   0x09a,   0x10,      100, 
0x08ad,   0x0e3,   0x3c,      200,
0x05ed,   0x09b,   0x2c,      300,
0x075b,   0x0c1,   0x10,      400,
0x0385,   0x05c,   0x1e,      500, 
0x03e4,   0x066,   0x0e,      600,
0x5dd,    0x09a,   0x03,      700,
0x752,    0x0c0,   0x15,      800, 
0x534,    0x088,   0x2d,      900,
0x258,    0x03d,   0x25,     1000,
0x884,    0x0df,   0x2f,     1100,
0x949,    0x0f3,   0x3d,     1200,
0x5db,    0x099,   0x36,     1300,
0x499,    0x078,   0x33,     1400,
0x6a7,    0x0ae,   0x32,     1500,
0xaf6,    0x11f,   0x3f,     1600, 
0x47b,    0x075,   0x2e,     1700,
0x630,    0x0a2,   0x2b,     1800,
0x93e,    0x0f2,   0x35,     1900,
};


unsigned long FT_Number = 1234567890;

void setup() {
  Serial.begin(115200);  
  Serial.print("// "); 
  Serial.println(Version);
  Serial.println("");  
  Serial.println(""); 
  
  Serial.println("long int FineTuneHEX []");
  Serial.println("{");  
  for (int i=0; i<80; i=i+4)
  { FT_Number = (FineTune[i]);
    FT_Number = (FT_Number <<10);
    FT_Number = (FT_Number | (FineTune[i+1]));
    FT_Number = (FT_Number << 7);
    FT_Number = (FT_Number | (FineTune[i+2]));
    FT_Number = (FT_Number << 1);  
    FT_Number = (FT_Number +1);   // set the control bit
    
    Serial.print("0x");
    Serial.print (FT_Number, HEX); 
    Serial.print(",  //    +"); 
    Serial.println(FineTune[i+3]);   
  }
  Serial.println("};");  

  Serial.println("");  
  Serial.println(""); 
  Serial.println("long int FineTune []");
  Serial.println("{"); 
  for (int i=0; i<80; i=i+4)
  { FT_Number = (FineTune[i]);
    FT_Number = (FT_Number <<10);
    FT_Number = (FT_Number | (FineTune[i+1]));
    FT_Number = (FT_Number << 7);
    FT_Number = (FT_Number | (FineTune[i+2]));
    FT_Number = (FT_Number << 1);  
    FT_Number = (FT_Number +1);   // set the control bit  
    Serial.print (FT_Number); 
    Serial.print(",  //    +"); 
    Serial.println(FineTune[i+3]);  
  }
  Serial.println("};");  
}

void loop() {
  // put your main code here, to run repeatedly:
}
